Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 676878 - x11-libs/wxGTK - backport patch to ignore new GXX ABI versions
Summary: x11-libs/wxGTK - backport patch to ignore new GXX ABI versions
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Gentoo wxWidgets Herd
URL:
Whiteboard:
Keywords: PATCH
Depends on:
Blocks:
 
Reported: 2019-01-29 23:14 UTC by Brian Evans
Modified: 2019-08-11 14:11 UTC (History)
2 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
relax ABI patch for gcc (relax-ABI.patch,1.17 KB, patch)
2019-01-29 23:14 UTC, Brian Evans
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Brian Evans Gentoo Infrastructure gentoo-dev 2019-01-29 23:14:07 UTC
Created attachment 563246 [details, diff]
relax ABI patch for gcc

Upstream has added patches to wx/build.h as it was agreed that the GXX_ABI_VERSION that shipped with gcc 3.4 has been stable and does not affect wxWidgets.

Discussion on this topic is at [1].
The patch includes commits [2] since d31cfba54091 excluding f1dfb27 which was for Visual Studio only.

It should apply to all current and future versions until 3.1.2 where it already exists.

Highly suggest changing the a subslot on this package as runtime breakage until rebuild of everything is complete or else mention a revdep-rebuild.

This will prevent the existing ABI issues that plague wxGTK users and a small price to pay.


[1] http://wxwidgets.10942.n7.nabble.com/quot-Mismatch-between-program-and-library-quot-C-ABI-1008-vs-1002-td88591.html
[2] https://github.com/wxWidgets/wxWidgets/commits/master/include/wx/build.h
Comment 1 Mart Raudsepp gentoo-dev 2019-01-31 10:36:06 UTC
There are no subslots for wxGTK; so basically this revbump would then break all consumers yet again, this time without a GCC change?
Comment 2 Brian Evans Gentoo Infrastructure gentoo-dev 2019-01-31 13:30:40 UTC
(In reply to Mart Raudsepp from comment #1)
> There are no subslots for wxGTK; so basically this revbump would then break
> all consumers yet again, this time without a GCC change?

Yes it will break for one, last time.  Including the patch and revdep-rebuild instructions, when REPLACING_VERSIONS is non-empty, would be enough for this expected change.

Users would no longer face each gcc version change to rebuild all wx apps/libs manually.  This is the goal which makes the rebuild worth it.
Comment 3 Pál Csányi 2019-03-15 20:03:01 UTC
I also have an issue regarding this.

I must to run this command (thanks #gentoo) to solve it:
emerge -1av wxGTK:3.0
Comment 4 Brian Evans Gentoo Infrastructure gentoo-dev 2019-05-07 16:48:11 UTC
See also Debian's patch at https://salsa.debian.org/freewx-team/wx/blob/wx3.0-debian/debian/patches/warn-for-compiler-abi-mismatch.patch

Combining the two patches will likely enable a phase out as packages are recompiled.

Debian's patch alone will cause warnings.

Upstream's backported patch needs things recompiled if done alone.
Comment 5 Mart Raudsepp gentoo-dev 2019-07-14 10:44:25 UTC
(In reply to Brian Evans from comment #4)
> Debian's patch alone will cause warnings.

I don't think it'll cause any warnings. They had that initially, but it's commented out in current patch iteration (and I believe long before someone found the debian patch) due to causing issues if warning.
Comment 6 Larry the Git Cow gentoo-dev 2019-07-14 11:11:49 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=ba3219ff4f1da464d0d789ffa1c1f15d303610ca

commit ba3219ff4f1da464d0d789ffa1c1f15d303610ca
Author:     Mart Raudsepp <leio@gentoo.org>
AuthorDate: 2019-07-14 10:44:39 +0000
Commit:     Mart Raudsepp <leio@gentoo.org>
CommitDate: 2019-07-14 11:09:19 +0000

    x11-libs/wxGTK: update patchset, ignore C++ ABI changes at startup
    
    Closes: https://bugs.gentoo.org/676878
    Package-Manager: Portage-2.3.62, Repoman-2.3.12
    Signed-off-by: Mart Raudsepp <leio@gentoo.org>

 x11-libs/wxGTK/Manifest                         |   1 +
 x11-libs/wxGTK/files/wxGTK-ignore-c++-abi.patch |  39 +++++
 x11-libs/wxGTK/wxGTK-3.0.4-r2.ebuild            | 141 ++++++++++++++++++
 x11-libs/wxGTK/wxGTK-3.0.4-r302.ebuild          | 185 ++++++++++++++++++++++++
 4 files changed, 366 insertions(+)